Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1)
@@ -1,77 +1,110 @@
-!> @file init_pegrid.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Current revisions:
-! ------------------
-!
+ SUBROUTINE init_pegrid
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! replaced use_syn_turb_gen by syn_turb_gen
-!
-! 4648 2020-08-25 07:52:08Z raasch
-! file re-formatted to follow the PALM coding standard
-!
-! 4564 2020-06-12 14:03:36Z raasch
-! Vertical nesting method of Huq et al. (2019) removed
-!
-! 4461 2020-03-12 16:51:59Z raasch
-! communicator configurations for four virtual pe grids defined
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! changed message PA0467
-!
-! 4264 2019-10-15 16:00:23Z scharf
-! corrected error message string
-!
-! 4241 2019-09-27 06:32:47Z raasch
-! Check added to ensure that subdomain grid has at least the size as given by the number of ghost
-! points
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4045 2019-06-21 10:58:47Z raasch
-! bugfix: kind attribute added to nint function to allow for large integers which may appear in case
-!         of default recycling width and small grid spacings
-!
-! 3999 2019-05-23 16:09:37Z suehring
-! Spend 3 ghost points also in case of pw-scheme when nesting is applied
-!
-! 3897 2019-04-15 11:51:14Z suehring
-! Minor revision of multigrid check; give warning instead of an abort.
-!
-! 3890 2019-04-12 15:59:20Z suehring
-! Check if grid coarsening is possible on subdomain, in order to avoid that multigrid approach
-! effectively reduces to a Gauss-Seidel scheme.
-!
-! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction of additional debug
-! messages
-!
-! 3884 2019-04-10 13:31:55Z Giersch
-! id_recycling is only calculated in case of tubulent inflow
-!
-! 3761 2019-02-25 15:31:42Z raasch
-! unused variable removed
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! variables documented
+! $Log: init_pegrid.f90,v $
+! Revision 1.28  2006/04/26 13:23:32  raasch
+! lcmuk does not understand the !$ comment so a cpp-directive is required
+!
+! Revision 1.27  2006/04/26 12:50:32  raasch
+! Get the number of OpenMP threads
+!
+! Revision 1.26  2006/02/23 12:34:57  raasch
+! Calculation of nanz_sums, nanz_2dh and nanz_3d moved to init_3d_model,
+! anz_y.. renamed ngp_y.., + MPI type type_x_int
+!
+! Revision 1.25  2005/10/20 15:37:36  raasch
+! error removed: the last PE in a row is not allowed to have more grid points
+! than the other PES (only less)
+!
+! Revision 1.24  2005/03/26 20:35:06  raasch
+! Extensions for non-cyclic boundary conditions
+! MIN function must be used instead of MAX for deciding if a switch to PE0 is
+! useful (multigrid-method), maximuma_grid_level_l is defined in case that a
+! pre-defined value for mg_switch_to_pe0_level is given (caused errors on NEC)
+!
+! Revision 1.23  2004/04/30 12:27:13  raasch
+! Setting 1d-decomposition as default on decalpha, indices for direct
+! transpositions z --> y and y --> x added, +module poisfft_mod,
+! data types for mpi_alltoallv removed (not neeeded any more),
+! poisfft_hybrid is no longer enforced in case of a 1d-decomposition along x,
+! an enlarged grid which will fit all transposition demands is calculated,
+! impulse_advec renamed momentum_advec
+!
+! Revision 1.22  2003/10/29 08:56:20  raasch
+! Number of possible grid levels for the mulitgrid-method are calculated
+! based on the total domain grid
+!
+! Revision 1.21  2003/08/01 08:40:03  raasch
+! Error removed: for a 1D-decomposition along x, the number PEs must also
+! be an integral divisor of the number of gridpoints along y
+!
+! Revision 1.20  2003/05/09 14:27:26  raasch
+! Setting 1d-decomposition as default on linux clusters
+!
+! Revision 1.19  2003/04/16 13:00:11  raasch
+! Call of fft_1dd_init, +module fft_for_1d_decomp
+!
+! Revision 1.18  2003/03/16 09:39:57  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.17  2003/03/12 16:32:47  raasch
+! A 1d-decomposition along x is the default on NEC hosts
+!
+! Revision 1.16  2002/12/19 15:40:39  raasch
+! In case of 1d-decomposition along x only a part of the integral divisor
+! conditions is checked, on IBM hosts a 1d-decomposition along x is the
+! default, a switch from Poisson-FFT-solver to the hybrid-solver is made
+! in case of 1d-decomposition along x, the hybrid-solver does not force a
+! 1d-decomposition any more, STOP replaced by call of local_stop
+!
+! Revision 1.15  2002/06/11 13:10:58  raasch
+! Usage of the Poisson-hybrid-solver forces a 1d-decomposition,
+! initialization of hybrid-solver
+!
+! Revision 1.14  2001/08/21  09:49:45  09:49:45  raasch (Siegfried Raasch)
+! MPI_COMM_WORLD replaced by comm_palm
+! 
+! Revision 1.13  2001/07/20 13:07:26  raasch
+! In case of using multigrid method, grid levels and additional MPI derived data
+! types are calculated. anz_yz and type_xz are now arrays.
+!
+! Revision 1.12  2001/03/30 07:32:01  raasch
+! Calculations of nw and nw1 removed,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.11  2001/01/22 08:33:48  raasch
+! Module test_variables removed
+!
+! Revision 1.9  2000/12/28 13:16:37  raasch
+! definition of mpi_particle_type moved to subroutine init_particles
+!
+! Revision 1.8  2000/04/27 06:54:03  raasch
+! Processor topology can now be prescribed by the user using npex and npey,
+! all comments translated into English
+!
+! Revision 1.7  1999/11/25 16:23:36  raasch
+! MPI-Datentyp fuer Partikeltransfer vereinbart
+!
+! Revision 1.6  1998/07/16 06:50:23  raasch
+! cpp-Direktiven fuer t3ej2 und t3ej5 erweitert
+!
+! Revision 1.5  1998/07/06 12:17:06  raasch
+! + USE test_variables
+!
+! Revision 1.4  1998/03/18 20:13:42  raasch
+! myid_char auf 5 Zeichen erweitert
+!
+! Revision 1.3  1998/01/23 10:02:08  raasch
+! Gitterpunktzahlen und Datentyp fuer 2D-Randaustausch
+! anz_yz_p, type_xz_p in anz_yz und type_xz umbenannt
+!
+! Revision 1.2  1997/08/11 06:18:28  raasch
+! Gitterpunktanzahl von globalen Feldern werden berechnet
 !
 ! Revision 1.1  1997/07/24 11:15:09  raasch
@@ -81,122 +114,43 @@
 ! Description:
 ! ------------
-!> Determination of the virtual processor topology (if not prescribed by the user) and computation
-!> of the grid point number and array bounds of the local domains.
-!> @todo: remove MPI-data types for 2D exchange on coarse multigrid level (not used any more)
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE init_pegrid
-
-
-    USE control_parameters,                                                                        &
-        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r, bc_dirichlet_s, bc_lr, bc_ns,       &
-               bc_radiation_l, bc_radiation_n, bc_radiation_r, bc_radiation_s, grid_level,         &
-               grid_level_count, maximum_grid_level, message_string, mg_switch_to_pe0_level, psolver
-
-
-#if defined( __parallel )
-    USE control_parameters,                                                                        &
-        ONLY:  coupling_mode, coupling_topology, gathered_size, momentum_advec,                    &
-               outflow_source_plane, recycling_width, scalar_advec, subdomain_size,                &
-               syn_turb_gen, turbulent_inflow, turbulent_outflow, y_shift
-
-    USE grid_variables,                                                                            &
-        ONLY:  dx
-#endif
-
-    USE indices,                                                                                   &
-        ONLY:  nnx, nny, nnz, nx, nxl, nxl_mg, nxlu, nxr, nxr_mg, ny, nyn, nyn_mg, nys, nys_mg,    &
-               nysv, nz, nzb, nzt, nzt_mg, wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4, &
-               wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8, wall_flags_9, wall_flags_10
-
-#if defined( __parallel )
-    USE indices,                                                                                   &
-        ONLY:  mg_loc_ind, nbgp, nx_a, nx_o, ny_a, ny_o
-#endif
-
-    USE kinds
-
+! Determination of the virtual processor topology (if not prescribed by the
+! user)and computation of the grid point number and array bounds of the local
+! domains.
+!------------------------------------------------------------------------------!
+
+    USE control_parameters
+    USE fft_xy
+    USE indices
     USE pegrid
-
-#if defined( __parallel )
-    USE pmc_interface,                                                                             &
-        ONLY:  nested_run
-
-    USE spectra_mod,                                                                               &
-        ONLY:  calculate_spectra
-
-    USE synthetic_turbulence_generator_mod,                                                        &
-        ONLY:  id_stg_left, id_stg_north, id_stg_right, id_stg_south
-#endif
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_y, nxl_z, nxr_y, nxr_z, nyn_x, nyn_z, nys_x, nys_z, nzb_x, nzb_y, nzt_x, nzt_y
-
-#if defined( __parallel )
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_yd, nxr_yd, nzb_yd, nzt_yd
-#endif
+    USE poisfft_mod
+    USE poisfft_hybrid_mod
+    USE statistics
+    USE transpose_indices
+
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                        !< running index over number of processors or number of multigrid level
-#if defined( __parallel )
-    INTEGER(iwp) ::  id_inflow_l              !< ID indicating processors located at the left inflow boundary
-    INTEGER(iwp) ::  id_outflow_l             !< local value of id_outflow
-    INTEGER(iwp) ::  id_outflow_source_l      !< local value of id_outflow_source
-    INTEGER(iwp) ::  id_recycling_l           !< ID indicating processors located at the recycling plane
-    INTEGER(iwp) ::  id_stg_left_l            !< left lateral boundary local core id in case of turbulence generator
-    INTEGER(iwp) ::  id_stg_north_l           !< north lateral boundary local core id in case of turbulence generator
-    INTEGER(iwp) ::  id_stg_right_l           !< right lateral boundary local core id in case of turbulence generator
-    INTEGER(iwp) ::  id_stg_south_l           !< south lateral boundary local core id in case of turbulence generator
-    INTEGER(iwp) ::  ind(5)                   !< array containing the subdomain bounds
-#endif
-    INTEGER(iwp) ::  j                        !< running index, used for various loops
-    INTEGER(iwp) ::  k                        !< number of vertical grid points in different multigrid level
-    INTEGER(iwp) ::  maximum_grid_level_l     !< maximum number of grid level without switching to PE 0
-    INTEGER(iwp) ::  mg_levels_x              !< maximum number of grid level allowed along x-direction
-    INTEGER(iwp) ::  mg_levels_y              !< maximum number of grid level allowed along y-direction
-    INTEGER(iwp) ::  mg_levels_z              !< maximum number of grid level allowed along z-direction
-    INTEGER(iwp) ::  mg_switch_to_pe0_level_l !< maximum number of grid level with switching to PE 0
-#if defined( __parallel )
-    INTEGER(iwp) ::  nnx_y                    !< quotient of number of grid points along x-direction and number of PEs used along y-direction
-    INTEGER(iwp) ::  nny_x                    !< quotient of number of grid points along y-direction and number of PEs used along x-direction
-    INTEGER(iwp) ::  nny_z                    !< quotient of number of grid points along y-direction and number of PEs used along x-direction
-    INTEGER(iwp) ::  nnz_x                    !< quotient of number of grid points along z-direction and number of PEs used along x-direction
-    INTEGER(iwp) ::  nnz_y                    !< quotient of number of grid points along z-direction and number of PEs used along x-direction
-    INTEGER(iwp) ::  numproc_sqr              !< square root of the number of processors
-#endif
-    INTEGER(iwp) ::  nxl_l                    !< lower index bound along x-direction on subdomain and different multigrid level
-    INTEGER(iwp) ::  nxr_l                    !< upper index bound along x-direction on subdomain and different multigrid level
-    INTEGER(iwp) ::  nyn_l                    !< lower index bound along y-direction on subdomain and different multigrid level
-    INTEGER(iwp) ::  nys_l                    !< upper index bound along y-direction on subdomain and different multigrid level
-#if defined( __parallel )
-    INTEGER(iwp) ::  nzb_l                    !< lower index bound along z-direction on subdomain and different multigrid level
-#endif
-    INTEGER(iwp) ::  nzt_l                    !< upper index bound along z-direction on subdomain and different multigrid level
-!$  INTEGER(iwp) ::  omp_get_num_threads      !< number of OpenMP threads
-
-#if defined( __parallel )
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ind_all !< dummy array containing index bounds on subdomain, used for gathering
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxlf    !< lower index bound allong x-direction for every PE
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxrf    !< upper index bound allong x-direction for every PE
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nynf    !< lower index bound allong y-direction for every PE
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nysf    !< lower index bound allong y-direction for every PE
-
-    INTEGER(iwp), DIMENSION(2) ::  pdims_remote         !< number of PEs used for coupled model (only in atmospher-ocean coupling)
-    INTEGER(iwp)               ::  lcoord(2)            !< PE coordinates of left neighbor along x and y
-    INTEGER(iwp)               ::  rcoord(2)            !< PE coordinates of right neighbor along x and y
-#endif
+    INTEGER ::  gathered_size, i, ind(5), j, k, maximum_grid_level_l,     &
+                mg_switch_to_pe0_level_l, mg_levels_x, mg_levels_y,       &
+                mg_levels_z, nnx_y, nnx_z, nny_x, nny_z, nnz_x, nnz_y,    &
+                numproc_sqr, nx_total, nxl_l, nxr_l, nyn_l, nys_l, nzb_l, &
+                nzt_l, omp_get_num_threads, subdomain_size
+
+    INTEGER, DIMENSION(:), ALLOCATABLE ::  ind_all, nxlf, nxrf, nynf, nysf
+
+    LOGICAL ::  found
 
 !
 !-- Get the number of OpenMP threads
     !$OMP PARALLEL
+#if defined( __lcmuk )
+    threads_per_task = omp_get_num_threads()
+#else
 !$  threads_per_task = omp_get_num_threads()
+#endif
     !$OMP END PARALLEL
 
 
 #if defined( __parallel )
-
-    CALL location_message( 'creating virtual PE grids + MPI derived data types', 'start' )
-
 !
 !-- Determine the processor topology or check it, if prescribed by the user
@@ -205,21 +159,36 @@
 !
 !--    Automatic determination of the topology
-       numproc_sqr = SQRT( REAL( numprocs, KIND=wp ) )
-       pdims(1)    = MAX( numproc_sqr , 1 )
-       DO  WHILE ( MOD( numprocs , pdims(1) ) /= 0 )
-          pdims(1) = pdims(1) - 1
-       ENDDO
-       pdims(2) = numprocs / pdims(1)
+!--    The default on SMP- and cluster-hosts is a 1d-decomposition along x
+#if defined( __lcmuk )
+       host = 'lcmuk'
+#endif
+       IF ( host(1:3) == 'ibm'  .OR.  host(1:3) == 'nec'  .OR. &
+            host(1:2) == 'lc'   .OR.  host(1:3) == 'dec' )  THEN
+
+          pdims(1) = numprocs
+          pdims(2) = 1
+
+       ELSE
+
+          numproc_sqr = SQRT( REAL( numprocs ) )
+          pdims(1)    = MAX( numproc_sqr , 1 )
+          DO  WHILE ( MOD( numprocs , pdims(1) ) /= 0 )
+             pdims(1) = pdims(1) - 1
+          ENDDO
+          pdims(2) = numprocs / pdims(1)
+
+       ENDIF
 
     ELSEIF ( npex /= -1  .AND.  npey /= -1 )  THEN
 
 !
-!--    Prescribed by user. Number of processors on the prescribed topology must be equal to the
-!--    number of PEs available to the job
+!--    Prescribed by user. Number of processors on the prescribed topology
+!--    must be equal to the number of PEs available to the job
        IF ( ( npex * npey ) /= numprocs )  THEN
-          WRITE( message_string, * ) 'number of PEs of the prescribed ', 'topology (', npex*npey,  &
-                                     ') does not match & the number of ',                          &
-                                     'PEs available to the job (', numprocs, ')'
-          CALL message( 'init_pegrid', 'PA0221', 1, 2, 0, 6, 0 )
+          PRINT*, '+++ init_pegrid:'
+          PRINT*, '    number of PEs of the prescribed topology (', npex*npey, &
+                      ') does not match the number of PEs available to the ',  &
+                      'job (', numprocs, ')'
+          CALL local_stop
        ENDIF
        pdims(1) = npex
@@ -230,36 +199,20 @@
 !--    If the processor topology is prescribed by the user, the number of
 !--    PEs must be given in both directions
-       message_string = 'if the processor topology is prescribed by th' //                         &
-                        'e user & both values of "npex" and "npey" must be given' //               &
-                        ' in the &NAMELIST-parameter file'
-       CALL message( 'init_pegrid', 'PA0222', 1, 2, 0, 6, 0 )
-
-    ENDIF
-
-!
-!-- Create four default MPI communicators for the 2d virtual PE grid. One of them will be used as
-!-- the main communicator for this run, while others might be used for specific quantities like
-!-- aerosol, chemical species, or passive scalars), if their horizontal boundary conditions shall
-!-- be different from those of the other quantities (e.g. non-cyclic conditions for aerosols, and
-!-- cyclic conditions for all others).
-    DO  i = 1, 4
-
-       IF ( i == 1 )  cyclic = (/  .TRUE., .TRUE.  /)   ! cyclic along x and y
-       IF ( i == 2 )  cyclic = (/  .TRUE., .FALSE. /)   ! cyclic along x
-       IF ( i == 3 )  cyclic = (/ .FALSE., .TRUE.  /)   ! cyllic along y
-       IF ( i == 4 )  cyclic = (/ .FALSE., .FALSE. /)   ! non-cyclic
-
-       CALL MPI_CART_CREATE( comm_palm, ndim, pdims, cyclic, reorder,                              &
-                             communicator_configurations(i)%mpi_communicator, ierr )
-
-       CALL MPI_CART_SHIFT( communicator_configurations(i)%mpi_communicator, 0, 1,                 &
-                            communicator_configurations(i)%pleft,                                  &
-                            communicator_configurations(i)%pright, ierr )
-
-       CALL MPI_CART_SHIFT( communicator_configurations(i)%mpi_communicator, 1, 1,                 &
-                            communicator_configurations(i)%psouth,                                 &
-                            communicator_configurations(i)%pnorth, ierr )
-
-    ENDDO
+       PRINT*, '+++ init_pegrid:'
+       PRINT*, '    if the processor topology is prescribed by the user, ',   &
+                    'both values of "npex" and "npey" must be given in the ', &
+                    'NAMELIST-parameter file'
+       CALL local_stop
+
+    ENDIF
+
+!
+!-- The hybrid solver can only be used in case of a 1d-decomposition along x
+    IF ( pdims(2) /= 1  .AND.  psolver == 'poisfft_hybrid' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '*** init_pegrid: psolver = "poisfft_hybrid" can only be'
+          PRINT*, '                 used in case of a 1d-decomposition along x'
+       ENDIF
+    ENDIF
 
 !
@@ -268,79 +221,14 @@
     IF ( bc_ns /= 'cyclic' )  cyclic(2) = .FALSE.
 
-
-!
-!-- Set the main communicator (virtual pe grid) for this run
-    IF ( bc_lr == 'cyclic'  .AND.  bc_ns == 'cyclic' )  i = 1
-    IF ( bc_lr == 'cyclic'  .AND.  bc_ns /= 'cyclic' )  i = 2
-    IF ( bc_lr /= 'cyclic'  .AND.  bc_ns == 'cyclic' )  i = 3
-    IF ( bc_lr /= 'cyclic'  .AND.  bc_ns /= 'cyclic' )  i = 4
-
-    comm2d = communicator_configurations(i)%mpi_communicator
-    pleft  = communicator_configurations(i)%pleft
-    pright = communicator_configurations(i)%pright
-    psouth = communicator_configurations(i)%psouth
-    pnorth = communicator_configurations(i)%pnorth
-
-!
-!-- Set rank and coordinates of the main communicator
+!
+!-- Create the virtual processor grid
+    CALL MPI_CART_CREATE( comm_palm, ndim, pdims, cyclic, reorder, &
+                          comm2d, ierr )
     CALL MPI_COMM_RANK( comm2d, myid, ierr )
-    WRITE (myid_char,'(''_'',I6.6)')  myid
+    WRITE (myid_char,'(''_'',I4.4)')  myid
 
     CALL MPI_CART_COORDS( comm2d, myid, ndim, pcoord, ierr )
-
-!
-!-- In case of cyclic boundary conditions, a y-shift at the boundaries in x-direction can be
-!-- introduced via parameter y_shift. The shift is done by modifying the processor grid in such a
-!-- way that processors located at the x-boundary communicate across it to processors with
-!-- y-coordinate shifted by y_shift relative to their own. This feature can not be used in
-!-- combination with an fft pressure solver. It has been implemented to counter the effect of streak
-!-- structures in case of cyclic boundary conditions. For a description of these see Munters
-!-- (2016; dx.doi.org/10.1063/1.4941912)
-!--
-!-- Get coordinates of left and right neighbor on PE grid
-    IF ( y_shift /= 0 ) THEN
-       IF ( bc_lr == 'cyclic' ) THEN
-          IF ( TRIM( psolver ) /= 'multigrid' .AND.  TRIM( psolver ) /= 'multigrid_noopt')  THEN
-             message_string = 'y_shift /= 0 requires a multigrid pressure solver '
-             CALL message( 'check_parameters', 'PA0468', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          CALL MPI_CART_COORDS( comm2d, pright, ndim, rcoord, ierr )
-          CALL MPI_CART_COORDS( comm2d, pleft, ndim, lcoord, ierr )
-
-!
-!--       If the x(y)-coordinate of the right (left) neighbor is smaller (greater) than that of the
-!--       calling process, then the calling process is located on the right (left) boundary of the
-!--       processor grid. In that case, the y-coordinate of that neighbor is increased (decreased)
-!--       by y_shift.
-!--       The rank of the process with that coordinate is then inquired and the neighbor rank for
-!--       MPI_SENDRECV, pright (pleft) is set to it.
-!--       In this way, the calling process receives a new right (left) neighbor for all future
-!--       MPI_SENDRECV calls. That neighbor has a y-coordinate of y+(-)y_shift, where y is the
-!--       original right (left) neighbor's y-coordinate. The modulo-operation ensures that if the
-!--       neighbor's y-coordinate exceeds the grid-boundary, it will be relocated to the opposite
-!--       part of the grid cyclicly.
-          IF ( rcoord(1) < pcoord(1) )  THEN
-             rcoord(2) = MODULO( rcoord(2) + y_shift, pdims(2) )
-             CALL MPI_CART_RANK( comm2d, rcoord, pright, ierr )
-          ENDIF
-
-          IF ( lcoord(1) > pcoord(1) )  THEN
-             lcoord(2) = MODULO( lcoord(2) - y_shift, pdims(2) )
-             CALL MPI_CART_RANK( comm2d, lcoord, pleft, ierr )
-          ENDIF
-
-       ELSE
-!
-!--       y-shift for non-cyclic boundary conditions is only implemented
-!--       for the turbulence recycling method in inflow_turbulence.f90
-          IF ( .NOT. turbulent_inflow )  THEN
-             message_string = 'y_shift /= 0 is only allowed for cyclic ' //                        &
-                              'boundary conditions in both directions '  //                        &
-                              'or with turbulent_inflow == .TRUE.'
-             CALL message( 'check_parameters', 'PA0467', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
-    ENDIF
+    CALL MPI_CART_SHIFT( comm2d, 0, 1, pleft, pright, ierr )
+    CALL MPI_CART_SHIFT( comm2d, 1, 1, psouth, pnorth, ierr )
 
 !
@@ -358,16 +246,81 @@
     CALL MPI_COMM_RANK( comm1dy, myidy, ierr )
 
-!
-!-- Calculate array bounds along x-direction for every PE.
-    ALLOCATE( nxlf(0:pdims(1)-1), nxrf(0:pdims(1)-1), nynf(0:pdims(2)-1), nysf(0:pdims(2)-1) )
-
-    IF ( MOD( nx+1 , pdims(1) ) /= 0 )  THEN
-       WRITE( message_string, * ) 'x-direction: gridpoint number (' ,nx+1, ') ',                   &
-                                  'is not an& integral multiple of the number',                    &
-                                  ' of processors (', pdims(1), ')'
-       CALL message( 'init_pegrid', 'PA0225', 1, 2, 0, 6, 0 )
+
+!
+!-- Find a grid (used for array d) which will match the transposition demands
+    IF ( grid_matching == 'strict' )  THEN
+
+       nxa = nx;  nya = ny;  nza = nz
+
     ELSE
-       nnx  = ( nx + 1 ) / pdims(1)
-    ENDIF
+
+       found = .FALSE.
+   xn: DO  nxa = nx, 2*nx
+!
+!--       Meet conditions for nx
+          IF ( MOD( nxa+1, pdims(1) ) /= 0 .OR. &
+               MOD( nxa+1, pdims(2) ) /= 0 )  CYCLE xn
+
+      yn: DO  nya = ny, 2*ny
+!
+!--          Meet conditions for ny
+             IF ( MOD( nya+1, pdims(2) ) /= 0 .OR. &
+                  MOD( nya+1, pdims(1) ) /= 0 )  CYCLE yn
+
+
+         zn: DO  nza = nz, 2*nz
+!
+!--             Meet conditions for nz
+                IF ( ( MOD( nza, pdims(1) ) /= 0  .AND.  pdims(1) /= 1  .AND. &
+                       pdims(2) /= 1 )  .OR.                                  &
+                     ( MOD( nza, pdims(2) ) /= 0  .AND.  dt_dosp /= 9999999.9 &
+                     ) )  THEN
+                   CYCLE zn
+                ELSE
+                   found = .TRUE.
+                   EXIT xn
+                ENDIF
+
+             ENDDO zn
+
+          ENDDO yn
+
+       ENDDO xn
+
+       IF ( .NOT. found )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*,'+++ init_pegrid: no matching grid for transpositions found'
+          ENDIF
+          CALL local_stop
+       ENDIF
+
+    ENDIF
+
+!
+!-- Calculate array bounds in x-direction for every PE.
+!-- The last PE along x may get less grid points than the others
+    ALLOCATE( nxlf(0:pdims(1)-1), nxrf(0:pdims(1)-1), nynf(0:pdims(2)-1), &
+              nysf(0:pdims(2)-1), nnx_pe(0:pdims(1)-1), nny_pe(0:pdims(2)-1) )
+
+    IF ( MOD( nxa+1 , pdims(1) ) /= 0 )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*,'+++ x-direction:  gridpoint number (',nx+1,') is not an'
+          PRINT*,'                  integral divisor of the number of proces', &
+                                   &'sors (', pdims(1),')'
+       ENDIF
+       CALL local_stop
+    ELSE
+       nnx  = ( nxa + 1 ) / pdims(1)
+       IF ( nnx*pdims(1) - ( nx + 1) > nnx )  THEN
+          IF ( myid == 0 )  THEN
+	     PRINT*,'+++ x-direction: nx does not match the requirements ', &
+	                 'given by the number of PEs'
+             PRINT*,'                 used'
+             PRINT*,'    please use nx = ', nx - ( pdims(1) - ( nnx*pdims(1) &
+	                 - ( nx + 1 ) ) ), ' instead of nx =', nx
+          ENDIF
+	  CALL local_stop
+       ENDIF
+    ENDIF    
 
 !
@@ -376,16 +329,29 @@
        nxlf(i)   = i * nnx
        nxrf(i)   = ( i + 1 ) * nnx - 1
+       nnx_pe(i) = MIN( nx, nxrf(i) ) - nxlf(i) + 1
     ENDDO
 
 !
 !-- Calculate array bounds in y-direction for every PE.
-    IF ( MOD( ny+1 , pdims(2) ) /= 0 )  THEN
-       WRITE( message_string, * ) 'y-direction: gridpoint number (', ny+1, ') ',                   &
-                                  'is not an& integral multiple of the number',                    &
-                                  ' of processors (', pdims(2), ')'
-       CALL message( 'init_pegrid', 'PA0227', 1, 2, 0, 6, 0 )
+    IF ( MOD( nya+1 , pdims(2) ) /= 0 )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*,'+++ y-direction:  gridpoint number (',ny+1,') is not an'
+          PRINT*,'                  integral divisor of the number of proces', &
+                                   &'sors (', pdims(2),')'
+       ENDIF
+       CALL local_stop
     ELSE
-       nny  = ( ny + 1 ) / pdims(2)
-    ENDIF
+       nny  = ( nya + 1 ) / pdims(2)
+       IF ( nny*pdims(2) - ( ny + 1) > nny )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*,'+++ x-direction: nx does not match the requirements ', &
+                         'given by the number of PEs'
+             PRINT*,'                 used'
+             PRINT*,'    please use nx = ', nx - ( pdims(1) - ( nnx*pdims(1) &
+                         - ( nx + 1 ) ) ), ' instead of nx =', nx
+          ENDIF
+          CALL local_stop
+       ENDIF
+    ENDIF    
 
 !
